;--------------------------------------------------------------------
puts:
	push	bc
	push	de
	call	puts_core
	pop	de
	pop	bc
	ret
;
puts_core:
	push	hl
	ld	hl,(w_cur_xy)
	ld	c,l		;X
	ld	b,30h
	ld	l,h		;Y
	ld	h,0
	ld	e,l
	ld	d,h
	add	hl,hl	;*2
	add	hl,hl	;*4
	add	hl,de	;*5
	add	hl,hl	;*10
	add	hl,hl	;*20
	add	hl,hl	;*40
	add	hl,bc	;+x +VA
	ld	c,l
	ld	b,h
	pop	hl
	ld	a,(b_color)
	ld	d,a
puts_l:
	ld	a,(hl)
	inc	hl
	cp	20h
	jr	c,puts_ctrl
	out	(c),a
	res	4,b
	out	(c),d
	set	4,b
	inc	bc
	ld	a,(b_cur_x)
	inc	a
	ld	(b_cur_x),a
	cp	40
	jr	c,puts_l
;	jr	puts_cr
puts_cr:
	xor	a
	ld	(b_cur_x),a
	ld	a,(b_cur_y)
	inc	a
	ld	(b_cur_y),a
	jr	puts
;
puts_ctrl
	or	a
	ret	z
	cp	13
	jr	z,puts_cr
	cp	1
	jr	z,puts_locate
	jr	puts_l
;01,X,Y
puts_locate:
	ld	a,(hl)
	inc	hl
	ld	(b_cur_x),a
	inc	hl
	ld	(b_cur_y),a
	jr	puts

;--------------------------------------------------------------------
b_color:
	db	07
w_cur_xy:
b_cur_x:
	db	0
b_cur_y:
	db	0
