;--------------------------------------------------------------------
;X1 SUBCPU access
;
;--------------------------------------------------------------------
IO_SUBCPU   equ 1900H
IO_8255B   equ 1A01H

;--------------------------------------------------------------------
;80C49 -> Z80
to49:
TO80C49:
  push  bc
  ld    c,a
  call  WTC49
  LD   B,high IO_SUBCPU
  out   (c),c
  pop   bc
  ret
;--------------------------------------------------------------------
;
WTC49:
WTC:
  ld    a,high IO_8255B
  in    a,(low IO_8255B)
  and   040h
  JR   NZ,WTC
  RET

;--------------------------------------------------------------------
;
FROM80C49:
FO49:
  ld    a,high IO_8255B
  in    a,(low IO_8255B)
  and   20h
  jr    nz,FO49
  ld    a,high IO_SUBCPU
  in    a,(low IO_SUBCPU)
  RET
