;---------------------------------------
;starcruiser dynamic patch test
;
;CUI ２択選択メニュー
;
;---------------------------------------

MENU_TOP_Y		equ	10		;表示開始行
MENU_ITEM_X		equ	0		;項目表示桁
MENU_SEL_X		equ	15		;選択肢開始桁
MENU_STEP_X		equ	8		;選択肢送り
;
ITEM_COL		equ	07h	;項目色
ITEM_SEL_COL	equ	0Fh	;選択項目色
;
MENU_SEL_COL_OFF	equ	01h	;非選択色
MENU_SEL_COL_ON		equ	0Eh	;選択色

;----------------------------
;
b_cfg_sel_item:
	db	1
b_cfg_sel_item_max:
	db	0

;----------------------------
config:
;
config_l:
	ld	hl,d_cfg_data
	ld	de,D_CONFIG	;設定値へのポインタ
	call	cfg_show
config_kw1:
	call	inkey_ni
	cp	0dh
	ret	z
	or	a
	jr	nz,config_kw1
;
config_kw2:
	call	inkey_ni
	cp	0dh
	ret	z
;
	ld	de,D_CONFIG			;設定値へのポインタ
	ld	bc,(b_cfg_sel_item)	;選択項目
	cp	1eh
	jr	z,cfg_up
	cp	1fh
	jr	z,cfg_dn
	cp	20h
	jr	z,cfg_spc
	cp	1dh
	jr	z,cfg_lt
	cp	1ch
	jr	z,cfg_rt
	jr	config_kw2
;----------
;項目変更
cfg_spc:
cfg_lt:
cfg_rt:
	push	hl
	ld	l,c
	ld	h,0
	add	hl,de
	ld	a,(hl)
	xor	1
	ld	(hl),a
	pop	hl
	jr	config_l
;----------
;上
cfg_up:
	ld	a,c
	or	a
	jr	nz,$+2+1
	ld	a,b
	dec	a
cfg_item_set:
	ld	(b_cfg_sel_item),a
	jr	config_l
;----------
;下
cfg_dn:
	ld	a,c
	inc	a
	cp	b
	jr	c,cfg_item_set
	xor	a
	jr	cfg_item_set

;----------------------------
;コンフィギュレーションの設定と変更
;
;DE : 設定値のポインタ
;HL : メニュー文字列
cfg_show:
	ld	b,0			;num item
cfg_item_l:
;item
	ld	a,(hl)
	or	a
	jr	z,cfg_item_e
;set item color
	ld	a,(b_cfg_sel_item)
	cp	b
	ld	a,ITEM_COL
	jr	nz,$+4
	ld	a,ITEM_SEL_COL
	ld	(b_color),a
;
	push	bc
	ld	a,b
	add	a,MENU_TOP_Y
	ld	(b_cur_y),a
	ld	a,MENU_ITEM_X
	ld	(b_cur_x),a
;
	call	puts
;item setup
	ld	c,MENU_SEL_X
	ld	b,0
;selects
cfg_sel_l:
	ld	a,(hl)
	or	a
	jr	z,cfg_sel_e
;set color
	ld	a,(de)
	cp	b
	ld	a,MENU_SEL_COL_OFF
	jr	nz,$+4
	ld	a,MENU_SEL_COL_ON
	ld	(b_color),a
;locate
	ld	a,c
	ld	(b_cur_x),a
	call	puts
;X offset
	ld	a,c
	add	a,MENU_STEP_X
	ld	c,a
	inc	b
	jr	cfg_sel_l
;
cfg_sel_e:
	inc	hl
	inc	de
;Y offset
	pop	bc
	inc	b
	jr	cfg_item_l
;
cfg_item_e:
	ld	a,7
	ld	(b_color),a
	ld	a,b
	ld	(b_cfg_sel_item_max),a
	ret

;---------------------------------------
;itemの選択肢を返す
;in
;	hl : item top
;out
;	C  : num item
;
cfg_get_num_item:
	ld	c,0
cfg_get_num_item_l1:
	ld	a,(hl)
	inc	hl
	or	a
	ret	z
cfg_get_num_item_l2:
	ld	a,(hl)
	or	a
	jr	nz,cfg_get_num_item_l2
	inc	c
	jr	cfg_get_num_item_l1

;---------------------------------------
d_cfg_data:
;	dw	D_CONFIG	;設定値へのポインタ
;---------------------------------------
	db	"EMM DISK CACHE",0
	db	"NORMAL",0
	db	"DISABLE",0
	db	0
;---------------------------------------
	db	"SOUND SELECT",0
	db	"AUTO",0
	db	"PSG",0
	db	0
;---------------------------------------
	db	"POLYGON DRAWER",0
	db	"NORMAL",0
	db	"ADVANCE",0
	db	0
;---------------------------------------
	db	"KEYBOARD MODE",0
	db	"MODE-A",0
	db	0
;end
	db	0
;---------------------------------------
