;------------------------------------------------------------
; Patch & Executer for Z80
;
;memory map
;
;MEMORY SPACE
; 0000-FFFF   : target program (0000-FFFF)
; 0000-FFFF   : patcher , patch data
;
;------------------------------------------------------------

;------------------------------------------------------------
;patch
;
;in
;	hl : patch data top address
;
;patch data formast
;	dw	data_size (0000=END OF DATA)
;	dw	top_address
;	db	data x	data_size
;
patch:
;
patch_l:
;LEN
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	inc	hl
;check len
	ld	a,b
	or	c
	ret	z
;DST
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
;transfer
	ldir
	jr	patch_l
;
